<?php
/* This file is part of BNCwi v1.04.1 (20120713)
*
* copyright                  The BNCwi project
* license                    GNU General Public License
* author                     ipfrog, original code by Frederik Kriewitz
* modified and bugfixed      Oliver Schuetz
* email                      admin@oppserver.net
* version                    1.04.1 (20120713)
* page                       http://unix.oppserver.net/irc/bnc/
*
*/

function getmicrotime() { 
	list($usec, $sec) = explode(" ",microtime()); 
	return ((float)$usec + (float)$sec); 
} 

function mkpasswd($pwlength) {
srand((double)microtime()*1000000);
$Zeichen = "1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
$pawd = "";
while (strlen($pawd) < $pwlength)
{
	$pawd .= substr($Zeichen,(rand()%(strlen($Zeichen))),1);
}
return $pawd;
}

function bncconnect ($host, $port, $user, $pw, $nick="#") {
	if ($host == "" || $port == "" || $user == "" || $pw == "") return false;
	$fp=fsockopen($host,intval($port));
	fputs($fp, "NICK $nick\r\n");
	fputs($fp, "USER $user $_SERVER[REMOTE_ADDR] :$user\r\n");
	fputs($fp, "PASS $pw\r\n");
	sleep(1);
	$tmp=fread($fp,1024);
	if(substr_count($tmp, ":Falsches Password. Verbindung wird getrennt.") < 1 && substr_count($tmp, ":Wrong Password. Disconnecting.") < 1 && substr_count($tmp, ":Password errata. Disconnessione.") < 1  ) return $fp; else return false;
}

function getprivlog($logfile)
{
	if (file_exists($logfile))
	{
		return file($logfile);		
	}
	else
	{
		return false;
	}
}


function getmainlog($logfile, $zeilen)
{
	if (file_exists($logfile))
	{
		$loglines=file($logfile);
		$lines=count($loglines);
		if ($lines< $zeilen)
		{
			$zeilen = $lines;
		}
		$log = false;
		for($i=($lines-$zeilen); $i < $lines; $i++)
		{
			$log .= $loglines[$i]."<br>\n";
		}
		return $log;
	}
	else
	{
		return false;
	}
}
			
  
function getuserid ($configarray, $ident, $parentstatus=0) {
	foreach ($configarray as $line_num => $line) {
		if (substr_count($line, ".USER.LOGIN=$ident") >= 1) {
			$line = explode(".",$line, 2);
			$userid = trim(str_replace("USER", "", $line[0]));
			foreach ($configarray as $line_num2 => $line2) 
			{
				if (substr($line2, 0, 17+strlen($userid)) == "USER".$userid.".USER.PARENT=") 
				{
					$PARENT = trim(str_replace("USER".$userid.".USER.PARENT=", "", $line2));
					if(empty($PARENT)) $PARENT = 0;
					if($PARENT == $parentstatus)
					{
						return $userid;
					}
				}
			}
		}
	}
	if(empty($userid)) return false;
	return $userid;
}

function userexist ($configarray, $login) {
	foreach ($configarray as $line_num => $line) {
		if (substr_count($line, ".USER.LOGIN=$login") >= 1) {
			return true;
		}
	}
	return false;
}

function getuserconfig ($configarray, $userid) {
	foreach ($configarray as $line_num => $line) 
	{
		if (substr($line, 0, 10+strlen($userid)) == "USER".$userid.".USER.") 
		{
			$tempsettings = trim(str_replace("USER".$userid.".USER.", "", $line));
			$tempsettings = explode("=", $tempsettings, 2);
			$settings[$tempsettings[0]] = $tempsettings[1];
		}
	}
	if (!empty($settings)) 
		return array('ID'=>$userid, 'LOGIN'=>$settings['LOGIN'], 'USER'=>$settings['USER'], 'PASS'=>$settings['PASS'], 'RIGHTS'=>$settings['RIGHTS'], 'VLINK'=>$settings['VLINK'], 'PPORT'=>$settings['PPORT'], 'PARENT'=>$settings['PARENT'], 'QUITTED'=>$settings['QUITTED'], 'DCCENABLED'=>$settings['DCCENABLED'], 'AUTOGETDCC'=>$settings['AUTOGETDCC'], 'AIDLE'=>$settings['AIDLE'], 'LEAVEQUIT'=>$settings['LEAVEQUIT'], 'AUTOREJOIN'=>$settings['AUTOREJOIN'], 'AUTOREJOIN'=>$settings['AUTOREJOIN'], 'SYSMSG'=>$settings['SYSMSG'], 'LASTLOG'=>$settings['LASTLOG'], 'AWAYNICK'=>$settings['AWAYNICK'], 'LEAVEMSG'=>$settings['LEAVEMSG'], 'VHOST'=>$settings['VHOST'], 'NICK'=>$settings['NICK']);
	else
		return false;
}

function getuserchannels ($configarray, $userid) {
	foreach ($configarray as $line_num => $line) {
		if (substr_count($line, "USER$userid.CHANNELS.ENTRY")) {
			$line = explode("=#",$line, 2);
			$chanid = str_replace("USER$userid.CHANNELS.ENTRY", "", $line[0]);
			$channel[] = array($chanid, "#".$line[1]);
		}
	}
	return $channel;
}

function getuserservers ($configarray, $userid) {
	foreach ($configarray as $line_num => $line) {
		if (substr_count($line, "USER$userid.SERVERS.SERVER")) {
			$line = explode("=",$line, 2);
			$serverid = str_replace("USER$userid.SERVERS.SERVER", "", $line[0]);
			$serverhost = trim($line[1]);
			foreach ($configarray as $line_num1 => $line1) {
				if (substr_count($line1, "USER$userid.SERVERS.PORT$serverid")) $port = str_replace("USER$userid.SERVERS.PORT$serverid=", "", $line1);
			}
			$server[] = array($serverid, $serverhost, $port);
		}
	}
	return $server;
}

function getusers ($configarray) {
	foreach ($configarray as $line_num => $line) {
		if(eregi('USER[0-9]+.USER.LOGIN=',$line))
		{
			$loginline = explode("=",trim($line), 2);
			$login = $loginline[1];
			$userid = explode(".",$loginline[0]);
			$userid = trim($userid[0], "USER");
			for($a=$line_num+1; $a < sizeof($configarray); $a++)
			{
				if(substr_count($configarray[$a], "USER$userid.USER.RIGHTS="))
				{
					$admin = explode("=",$configarray[$a]);
					$admin = trim($admin[1]);
					break;
				}
			}
			if ($admin == 1) $admin = 1; else $admin = 0;
			$users[] = array($userid, $login, $admin);
		}
	}
	return $users;
}

function writescriptfile ($serverid, $userid, $login) {
	global $table_server;
	global $table_script_qauth;
	global $lang_extras_qauth_bhelp;
	global $table_script_nickservauth;
	global $table_script_custom;
	global $table_script_main;
	global $scriptchmod;
	if ($scriptchmod != "")
	{
		$chmod = $scriptchmod;
	}
	else
	{
		$chmod = 0644;
	}
	$result = mysql_query("SELECT * FROM `$table_server` WHERE `id` = $serverid");
	$data = mysql_fetch_array($result);
	$scriptpath = $data['path']."/scripts/USER".$userid.".SCRIPT";
	if ($scriptfile = fopen ($scriptpath, "w+"))
	{
		$result = mysql_query("SELECT * FROM `$table_script_qauth` WHERE `serverid` = '$serverid' AND `login` = '$login'");
		if (mysql_num_rows($result) != 0)
		{
			$data = mysql_fetch_array($result);
			fwrite($scriptfile, "server NOTICE * * \"*Highest connection count*\" echo \"PRIVMSG q@cserve.quakenet.org :auth ".str_replace('$(', "\\\$(", str_replace('`', "\\`", addslashes($data['authname'])))." ".str_replace('$(', "\\\$(", str_replace('`', "\\`", addslashes($data['authpass'])))."\"\n");
			fwrite($scriptfile, "alias QAUTH \"$lang_extras_qauth_bhelp\" * * echo \"PRIVMSG q@cserve.quakenet.org :auth ".str_replace('$(', "\\\$(", str_replace('`', "\\`", addslashes($data['authname'])))." ".str_replace('$(', "\\\$(", str_replace('`', "\\`", addslashes($data['authpass'])))."\"\n");
			if ($data['set+x'] == 1)
			{
				fwrite($scriptfile, "server NOTICE * * \"*Highest connection count*\" echo \"MODE \$USERNICK +x\"\n");
			}
		}
		$result = mysql_query("SELECT * FROM `$table_script_nickservauth` WHERE `serverid` = '$serverid' AND `login` = '$login'");
		if (mysql_num_rows($result) != 0)
		{
			$data = mysql_fetch_array($result);
			fwrite($scriptfile, "server NOTICE NickServ!*@* * \"*Dieser Nickname ist registriert*\" echo \"PRIVMSG NickServ :IDENTIFY ".str_replace('$(', "\\\$(", str_replace('`', "\\`", addslashes($data['password'])))."\"\n");
			fwrite($scriptfile, "server NOTICE NickServ!*@* * \"*This nickname is registered*\" echo \"PRIVMSG NickServ :IDENTIFY ".str_replace('$(', "\\\$(", str_replace('`', "\\`", addslashes($data['password'])))."\"\n");
			fwrite($scriptfile, "server NOTICE NickServ!*@* * \"*This nickname is owned by someone else*\" echo \"PRIVMSG NickServ :IDENTIFY ".str_replace('$(', "\\\$(", str_replace('`', "\\`", addslashes($data['password'])))."\"\n\n");
		}
		$result = mysql_query("SELECT * FROM `$table_script_main` WHERE `serverid` = '$serverid' AND `login` = '$login'");
		if (mysql_num_rows($result) != 0)
		{
			$data = mysql_fetch_array($result);
			if ($data['joinoninvite'] == 1)
			{
				fwrite($scriptfile, "server INVITE * * * echo \"JOIN \$P4\"\n");
			}
			if ($data['offlinemsgquery'] != "")
			{
				fwrite($scriptfile, "server PRIVMSG *!*@* * * if [ \"\$USERNICK\" = \"\$P3\" ] && [ \"\$USERON\" = \"0\" ]; then echo \"PRIVMSG \$NICK :".str_replace('$(', "\\\$(", str_replace('`', "\\`", addslashes($data['offlinemsgquery'])))."\"; fi;\n");
			}
			if ($data['offlinemsgchannel'] != "")
			{
				fwrite($scriptfile, "server PRIVMSG *!*@* * * if ( [ \":\$USERNICK\" = \"\$P4\" ] || [ \"\$USERNICK\" = \"\$P5\" ] || [ \"\$USERNICK\" = \"\$P6\" ] || [ \"\$USERNICK\" = \"\$P7\" ] || [ \"\$USERNICK\" = \"\$P8\" ] || [ \"\$USERNICK\" = \"\$P9\" ] || [ \"\$USERNICK\" = \"\$P10\" ] || [ \"\$USERNICK\" = \"\$P11\" ] || [ \"\$USERNICK\" = \"\$P12\" ] || [ \"\$USERNICK\" = \"\$P13\" ] || [ \"\$USERNICK\" = \"\$P14\" ] || [ \"\$USERNICK\" = \"\$P15\" ] || [ \"\$USERNICK\" = \"\$P16\" ] || [ \"\$USERNICK\" = \"\$P17\" ] || [ \"\$USERNICK\" = \"\$P18\" ] || [ \"\$USERNICK\" = \"\$P19\" ] || [ \"\$USERNICK\" = \"\$P20\" ] || [ \"\$USERNICK\" = \"\$P21\" ] || [ \"\$USERNICK\" = \"\$P22\" ] || [ \"\$USERNICK\" = \"\$P23\" ] || [ \"\$USERNICK\" = \"\$P24\" ] || [ \"\$USERNICK\" = \"\$P25\" ] || [ \"\$USERNICK\" = \"\$P26\" ] || [ \"\$USERNICK\" = \"\$P27\" ] || [ \"\$USERNICK\" = \"\$P28\" ] || [ \"\$USERNICK\" = \"\$P29\" ] || [ \"\$USERNICK\" = \"\$P30\" ] || [ \"\$USERNICK\" = \"\$P31\" ] || [ \"\$USERNICK\" = \"\$P32\" ] || [ \"\$USERNICK\" = \"\$P33\" ] || [ \"\$USERNICK\" = \"\$P34\" ] || [ \"\$USERNICK\" = \"\$P35\" ] || [ \"\$USERNICK\" = \"\$P36\" ] || [ \"\$USERNICK\" = \"\$P37\" ] || [ \"\$USERNICK\" = \"\$P38\" ] || [ \"\$USERNICK\" = \"\$P39\" ] || [ \"\$USERNICK\" = \"\$P40\" ] || [ \"\$USERNICK\" = \"\$P41\" ] || [ \"\$USERNICK\" = \"\$P42\" ] || [ \"\$USERNICK\" = \"\$P43\" ] || [ \"\$USERNICK\" = \"\$P44\" ] || [ \"\$USERNICK\" = \"\$P45\" ] || [ \"\$USERNICK\" = \"\$P46\" ] || [ \"\$USERNICK\" = \"\$P47\" ] || [ \"\$USERNICK\" = \"\$P48\" ] || [ \"\$USERNICK\" = \"\$P49\" ] || [ \"\$USERNICK\" = \"\$P50\" ] ) && [ `echo \$P3 | grep \#` ] && [ \"\$USERON\" = \"0\" ]; then echo \"PRIVMSG \$P3 :".str_replace('$(', "\\\$(", str_replace('`', "\\`", addslashes($data['offlinemsgchannel'])))."\"; fi;\n");
			}
		}
		$result = mysql_query("SELECT * FROM `$table_script_custom` WHERE `serverid` = '$serverid' AND `login` = '$login'");
		$data = mysql_fetch_array($result);
		fwrite($scriptfile, $data['script']);
		fclose($scriptfile);
		if ($scriptchmod != "0")
		{
			@chmod ($scriptpath, $chmod);
		}
		return true;
	}
	else
	{
		return false;
	}
}
?>